/**
 * @author Joel Espinosa Longi
 * @licencia LGPL - http://www.gnu.org/licenses/lgpl.html
 */

var editor = (function(editor) {

  /**
   *
   */
  editor.Controller = { functions: {} };

  /**
   *
   */
  editor.Controller.exec = function(funName, params) {
    // ToDo: check the values
    this.functions[funName](params);
  }

  /**
   *
   */
  editor.Controller.functions.newFile = function() {
    console.log("new file");
    this.closeFile();
    editor.filename = null;
    editor.ContentManager.closeFile();

    editor.ContentManager.openFile( path.normalize(__dirname + "/template/index.html") );
    // editor.ContentManager.openFile( path.normalize( "src/template/index.html") );

    document.title = editor.titleBase;
  }

  /**
   *
   */
  editor.Controller.functions.openFile = function(filename) {
    console.log("open file");
    this.closeFile();
    editor.filename = filename;
    editor.ContentManager.openFile(filename);

    document.title = editor.titleBase + filename;
  }

  /**
   *
   */
  editor.Controller.functions.saveFile = function(filename) {
    console.log("save file");
    editor.filename = filename;
    editor.ContentManager.saveFile(filename);

    document.title = editor.titleBase + filename;
  }

  /**
   *
   */
  editor.Controller.functions.closeFile = function() {
    console.log("close file");
    editor.filename = null;
    editor.ContentManager.closeFile();

    document.title = editor.titleBase;
  }

  return editor;
})(editor || {});