/**
 * @author Joel Espinosa Longi
 * @licencia LGPL - http://www.gnu.org/licenses/lgpl.html
 */

var paramEditor = (function(paramEditor) {

  /**
   *
   */
  paramEditor.LabelAndMenu = function(label, options, value) {
    this.name = label;
    this.options = options;
    this.value = value;

    var rnd = parseInt(Math.random()*1000);
    this.domObj = document.createElement("div");
    this.domObj.setAttribute("class", "LabelAndMenu");

    this.label = document.createElement("label");
    this.label.setAttribute("for", label+"_"+rnd);
    this.label.innerHTML = label;

    this.menu = document.createElement("select");
    this.menu.setAttribute("id", label+"_"+rnd);
    this.setValue(value);

    this.makeOptions(options)

    this.domObj.appendChild(this.label);
    this.domObj.appendChild(this.menu);

    var self = this;
    this.menu.addEventListener("change", function(evt) {
      console.log("cambio en", self.name);
      self.changeValue();
    });
  }

  /**
   *
   */
  paramEditor.LabelAndMenu.prototype.makeOptions = function(options) {
    // remove all previous children
    while (this.menu.firstChild) {
      this.menu.removeChilde(this.menu.firstChild);
    }

    // add the new children
    var tmpOption;
    for (var i=0, l=options.length; i<l; i++) {
      tmpOption = document.createElement("option");
      tmpOption.setAttribute("value", options[i]);
      tmpOption.innerHTML = options[i];
      this.menu.appendChild(tmpOption);
    }
  }
  
  paramEditor.LabelAndMenu.prototype.setLabel = function(label) {
    this.name = label;
    this.label.innerHTML = label;
  }
  paramEditor.LabelAndMenu.prototype.getLabel = function() {
    return this.name;
  }
  paramEditor.LabelAndMenu.prototype.setValue = function(value) {
    this.menu.value = value;
  }
  paramEditor.LabelAndMenu.prototype.getValue = function() {
    return this.menu.value;
  }

  paramEditor.LabelAndMenu.prototype.changeValue = function() {
    if (this.modelObj) {
      this.modelObj[this.name] = this.menu.value;
    }
    if (this.list) {
      this.list.updatePresentation();
    }
  }

  paramEditor.LabelAndMenu.prototype.setModelObj = function(obj, list) {
    this.modelObj = obj;
    this.list = list;
    this.setValue( obj[this.name] );
  }

  return paramEditor;
})(paramEditor || {});