/**
 * @author Joel Espinosa Longi
 * @licencia LGPL - http://www.gnu.org/licenses/lgpl.html
 */

var paramEditor = (function(paramEditor) {

  /**
   *
   */
  paramEditor.LabelAndTextfield = function(label, size, value) {
    this.name = label;
    this.value = value;

    var rnd = parseInt(Math.random()*1000);
    this.domObj = document.createElement("div");
    this.domObj.setAttribute("class", "LabelAndTextfield");

    this.label = document.createElement("label");
    this.label.setAttribute("for", label+"_"+rnd);
    this.label.innerHTML = label;

    this.textfield = document.createElement("input");
    this.textfield.setAttribute("id", label+"_"+rnd);
    this.textfield.setAttribute("type", "text");
    this.textfield.setAttribute("style", "width:"+size+";");
    this.setValue(value);

    this.domObj.appendChild(this.label);
    this.domObj.appendChild(this.textfield);

    var self = this;
    this.textfield.addEventListener("change", function(evt) {
      console.log("cambio en", self.name);
      self.changeValue();
    });
  }

  /**
   *
   */
  paramEditor.LabelAndTextfield.prototype.setLabel = function(label) {
    this.name = label;
    this.label.innerHTML = label;
  }
  paramEditor.LabelAndTextfield.prototype.getLabel = function() {
    return this.name;
  }
  paramEditor.LabelAndTextfield.prototype.setValue = function(value) {
    this.textfield.value = value;
  }
  paramEditor.LabelAndTextfield.prototype.getValue = function() {
    return this.textfield.value;
  }

  paramEditor.LabelAndTextfield.prototype.changeValue = function() {
    if (this.modelObj) {
      this.modelObj[this.name] = this.textfield.value;
      // console.log(this.modelObj)
    }
    if (this.list) {
      this.list.updatePresentation();
    }
  }

  paramEditor.LabelAndTextfield.prototype.setModelObj = function(obj, list) {
    this.modelObj = obj;
    this.list = list;
    this.setValue( obj[this.name] );
  }

  return paramEditor;
})(paramEditor || {});
