/**
 * @author Joel Espinosa Longi
 * @licencia LGPL - http://www.gnu.org/licenses/lgpl.html
 */

var paramEditor = (function(paramEditor) {

  /**
   *
   */
  paramEditor.PanelAnimation = function(type) {
    this.container = document.createElement("div"),
    this.container.setAttribute("class", "panel");
    this.components = {};

    // useAnimation component
    this.components.useAnimation = new paramEditor.LabelAndCheckbox("useAnimation", false);
    this.container.appendChild(this.components.useAnimation.domObj);

    this.container.appendChild(document.createElement("br"));

    // delay component
    this.components.delay = new paramEditor.LabelAndTextfield("delay", 250, "");
    this.container.appendChild(this.components.delay.domObj);

    // // controls component
    // this.components.controls = new paramEditor.LabelAndCheckbox("controls", false);
    // this.container.appendChild(this.components.controls.domObj);

    // auto component
    this.components.auto = new paramEditor.LabelAndCheckbox("auto", false);
    this.container.appendChild(this.components.auto.domObj);

    // loop component
    this.components.loop = new paramEditor.LabelAndCheckbox("loop", false);
    this.container.appendChild(this.components.loop.domObj);

    this.container.appendChild(document.createElement("br"));

    // ToDo: posiblemente cambiar a un componente que permita aumentar el area para editar su valor
    // init component
    this.components.init = new paramEditor.LabelAndTextfield("init", 250, "");
    this.container.appendChild(this.components.init.domObj);

    this.container.appendChild(document.createElement("br"));

    // ToDo: posiblemente hacer un text area
    // doExpr component
    this.components.doExpr = new paramEditor.LabelAndTextfield("doExpr", 250, "");
    this.container.appendChild(this.components.doExpr.domObj);

    this.container.appendChild(document.createElement("br"));

    // ToDo: posiblemente cambiar a un componente que permita aumentar el area para editar su valor
    // whileExpr component
    this.components.whileExpr = new paramEditor.LabelAndTextfield("whileExpr", 250, "");
    this.container.appendChild(this.components.whileExpr.domObj);

  }

  /**
   *
   */
  paramEditor.PanelAnimation.prototype.setEditPanel = function(panel) {
    this.editPanel = panel;
  }

  /**
   *
   */
  paramEditor.PanelAnimation.prototype.setModelObj = function(objModel) {
    this.objModel = objModel;

    // traverse the values of the components to asign the object model
    for (var propName in this.components) {
      // verify the own properties of the object
      if (this.components.hasOwnProperty(propName)) {
        // show only the attributes of the object
        this.components[propName].domObj.style.display = (objModel[propName] != undefined) ? "inline-block" : "none";

        // verify the own properties of the object
        if (this.components[propName].setModelObj) {
          this.components[propName].setModelObj(objModel, this.editPanel);
        }
      }
    }
  }

  return paramEditor;
})(paramEditor || {});
