/**
 * @author Joel Espinosa Longi
 * @licencia LGPL - http://www.gnu.org/licenses/lgpl.html
 */

var paramEditor = (function(paramEditor) {

  /**
   *
   */
  paramEditor.PanelButtons = function(type) {
    this.components = {};
    this.container = document.createElement("div");
    this.container.setAttribute("class", "panel");

    // width component
    this.components.width = new paramEditor.LabelAndTextfield("width", 100, 970);
    this.container.appendChild(this.components.width.domObj);

    // height component
    this.components.height = new paramEditor.LabelAndTextfield("height", 100, 550);
    this.container.appendChild(this.components.height.domObj);

    this.container.appendChild(document.createElement("br"));

    // about component
    this.components.about = new paramEditor.LabelAndCheckbox("about", false);
    this.container.appendChild(this.components.about.domObj);

    // config component
    this.components.config = new paramEditor.LabelAndCheckbox("config", false);
    this.container.appendChild(this.components.config.domObj);

    // init component
    this.components.init = new paramEditor.LabelAndCheckbox("init", false);
    this.container.appendChild(this.components.init.domObj);

    // clear component
    this.components.clear = new paramEditor.LabelAndCheckbox("clear", false);
    this.container.appendChild(this.components.clear.domObj);

    // editor component
    this.components.editor = new paramEditor.LabelAndCheckbox("editor", false);
    this.container.appendChild(this.components.editor.domObj);

    this.container.appendChild(document.createElement("br"));

    // rowsNorth component
    this.components.rowsNorth = new paramEditor.LabelAndTextfield("rowsNorth", 100, 0);
    this.container.appendChild(this.components.rowsNorth.domObj);

    // rowsSouth component
    this.components.rowsSouth = new paramEditor.LabelAndTextfield("rowsSouth", 100, 0);
    this.container.appendChild(this.components.rowsSouth.domObj);

    // widthWest component
    this.components.widthWest = new paramEditor.LabelAndTextfield("widthWest", 100, 150);
    this.container.appendChild(this.components.widthWest.domObj);

    // widthEast component
    this.components.widthEast = new paramEditor.LabelAndTextfield("widthEast", 100, 150);
    this.container.appendChild(this.components.widthEast.domObj);

    // heightRow component
    this.components.heightRows = new paramEditor.LabelAndTextfield("heightRows", 100, 40);
    this.container.appendChild(this.components.heightRows.domObj);

    this.container.appendChild(document.createElement("br"));

    // decimal_symbol
    this.components.decimal_symbol = new paramEditor.LabelAndMenu("decimal_symbol", [",", "."], ",");
    this.container.appendChild(this.components.decimal_symbol.domObj);

    // language
    this.components.language = new paramEditor.LabelAndMenu("language", ["english", "español"], "english");
    this.container.appendChild(this.components.language.domObj);

  }

  paramEditor.PanelButtons.prototype.setModelObj = function(objModel) {
    // traverse the values of the components to asign the object model
    for (var propName in this.components) {
      // verify the own properties of the object
      if (this.components.hasOwnProperty(propName)) {
        // show only the attributes of the object
        if (objModel[propName] != undefined) {
          if (this.components[propName].setModelObj) {
            this.components[propName].setModelObj(objModel);
            this.components[propName].domObj.style.display = "inline-block";
          }
        }
        else {
          if ((objModel.buttons[propName]) && (this.components[propName].setModelObj)) {
            this.components[propName].setModelObj(objModel.buttons);
            this.components[propName].domObj.style.display = "inline-block";
          }
          // console.log(objModel[propName], propName, objModel.buttons[propName])
        }
    //     if (this.components[propName].setModelObj) {
    //       this.components[propName].setModelObj(objModel);
    //     }
    //     console.log(propName)
      }
    }

    // console.log(objModel)
  }

  return paramEditor;
})(paramEditor || {});