/**
 * @author Joel Espinosa Longi
 * @licencia LGPL - http://www.gnu.org/licenses/lgpl.html
 */

var paramEditor = (function(paramEditor) {

  /**
   *
   */
  paramEditor.PanelControls = function(type) {
    this.container = document.createElement("div"),
    this.container.setAttribute("class", "panel");
    this.components = {};

    ////////////////////////////////////////////////////////////////////////////////////////////
    // NUMERIC CONTROLS
    ////////////////////////////////////////////////////////////////////////////////////////////
    // id component
    this.components.id = new paramEditor.LabelAndTextfield("id", 100, "n1");
    this.container.appendChild(this.components.id.domObj);

    // gui component
    this.components.gui = new paramEditor.LabelAndMenu("gui", ["spinner", "textfield", "menu", "scrollbar", "button"], "spinner");
    this.container.appendChild(this.components.gui.domObj);

    ////////////////////////////////////////////////////////////////////////////////////
    // next components are only for textfield controls
    ////////////////////////////////////////////////////////////////////////////////////
    // onlyText component
    this.components.onlyText = new paramEditor.LabelAndCheckbox("onlyText", false);
    this.container.appendChild(this.components.onlyText.domObj);
    ////////////////////////////////////////////////////////////////////////////////////
    // previous components are only for textfield controls
    ////////////////////////////////////////////////////////////////////////////////////

    // region component
    this.components.region = new paramEditor.LabelAndMenu("region", ["south", "north", "east", "west", "external", "interior", "scenario"], "south");
    this.container.appendChild(this.components.region.domObj);

    // space component
    this.components.space = new paramEditor.LabelAndMenu("space", [], "spinner");
    this.container.appendChild(this.components.space.domObj);

    // name component
    this.components.name = new paramEditor.LabelAndTextfield("name", 100, "n1");
    this.container.appendChild(this.components.name.domObj);


    ////////////////////////////////////////////////////////////////////////////////////////////
    // GRAPHIC CONTROLS
    ////////////////////////////////////////////////////////////////////////////////////////////
    // size component
    this.components.size = new paramEditor.LabelAndTextfield("size", 100, "");
    this.container.appendChild(this.components.size.domObj);
    ////////////////////////////////////////////////////////////////////////////////////////////
    // GRAPHIC CONTROLS
    ////////////////////////////////////////////////////////////////////////////////////////////


    // expression component
    this.components.expression = new paramEditor.LabelAndTextfield("expression", 100, "(0,0)");
    this.container.appendChild(this.components.expression.domObj);

    // value component
    this.components.value = new paramEditor.LabelAndTextfield("value", 100, "0");
    this.container.appendChild(this.components.value.domObj);

    // incr component
    this.components.incr = new paramEditor.LabelAndTextfield("incr", 100, "0.1");
    this.container.appendChild(this.components.incr.domObj);

    // min component
    this.components.min = new paramEditor.LabelAndTextfield("min", 100, "");
    this.container.appendChild(this.components.min.domObj);

    // max component
    this.components.max = new paramEditor.LabelAndTextfield("max", 100, "");
    this.container.appendChild(this.components.max.domObj);

    // discrete component
    this.components.discrete = new paramEditor.LabelAndCheckbox("discrete", false);
    this.container.appendChild(this.components.discrete.domObj);

    // decimals component
    this.components.decimals = new paramEditor.LabelAndTextfield("decimals", 100, "2");
    this.container.appendChild(this.components.decimals.domObj);

    // fixed component
    this.components.fixed = new paramEditor.LabelAndCheckbox("fixed", true);
    this.container.appendChild(this.components.fixed.domObj);

    // exponentialif component
    this.components.exponentialif = new paramEditor.LabelAndTextfield("exponentialif", 100, "");
    this.container.appendChild(this.components.exponentialif.domObj);

    // visible component
    this.components.visible = new paramEditor.LabelAndCheckbox("visible", true);
    this.container.appendChild(this.components.visible.domObj);

    ////////////////////////////////////////////////////////////////////////////////////
    // next components are only for choice controls
    ////////////////////////////////////////////////////////////////////////////////////
    // options component
    this.components.options = new paramEditor.LabelAndTextfield("options", 500, "");
    this.container.appendChild(this.components.options.domObj);
    ////////////////////////////////////////////////////////////////////////////////////
    // previous components are only for choice controls
    ////////////////////////////////////////////////////////////////////////////////////


    ////////////////////////////////////////////////////////////////////////////////////////////
    // GRAPHIC CONTROLS
    ////////////////////////////////////////////////////////////////////////////////////////////
    // constraint component
    this.components.constraint = new paramEditor.LabelAndTextfield("constraint", 300, "");
    this.container.appendChild(this.components.constraint.domObj);


    ////////////////////////////////////////////////////////////////////////////////////
    // next components are only for button controls
    ////////////////////////////////////////////////////////////////////////////////////
    // color component
    this.components.color = new paramEditor.LabelAndColor("color", "");
    this.container.appendChild(this.components.color.domObj);

    // colorInt component
    this.components.colorInt = new paramEditor.LabelAndColor("colorInt", "");
    this.container.appendChild(this.components.colorInt.domObj);

    // bold component
    this.components.bold = new paramEditor.LabelAndCheckbox("bold", false);
    this.container.appendChild(this.components.bold.domObj);

    // italics component
    this.components.italics = new paramEditor.LabelAndCheckbox("italics", false);
    this.container.appendChild(this.components.italics.domObj);

    // underlined component
    this.components.underlined = new paramEditor.LabelAndCheckbox("underlined", false);
    this.container.appendChild(this.components.underlined.domObj);

    // font_size component
    this.components.font_size = new paramEditor.LabelAndTextfield("font_size", 100, "");
    this.container.appendChild(this.components.font_size.domObj);

    // image component
    this.components.image = new paramEditor.LabelAndTextfield("image", 200, "");
    this.container.appendChild(this.components.image.domObj);
    ////////////////////////////////////////////////////////////////////////////////////
    // previous components are only for button controls
    ////////////////////////////////////////////////////////////////////////////////////

    // action component
    this.components.action = new paramEditor.LabelAndMenu("action", ["", "calculate", "init", "clear", "animate", "open URL", "open Scene", "play"], "");
    this.container.appendChild(this.components.action.domObj);

    // ToDo: posiblemente cambiar a un componente que permita aumentar el area para editar su valor
    // parameter component
    this.components.parameter = new paramEditor.LabelAndTextfield("parameter", 250, "");
    this.container.appendChild(this.components.parameter.domObj);

    // drawif component
    this.components.drawif = new paramEditor.LabelAndTextfield("drawif", 100, 1);
    this.container.appendChild(this.components.drawif.domObj);

    // activeif component
    this.components.activeif = new paramEditor.LabelAndTextfield("activeif", 100, 1);
    this.container.appendChild(this.components.activeif.domObj);

    ////////////////////////////////////////////////////////////////////////////////////
    // next components are only for textfield controls
    ////////////////////////////////////////////////////////////////////////////////////
    // evaluate component
    this.components.evaluate = new paramEditor.LabelAndCheckbox("evaluate", false);
    this.container.appendChild(this.components.evaluate.domObj);

    // answer component
    this.components.answer = new paramEditor.LabelAndTextfield("answer", 100, "");
    this.container.appendChild(this.components.answer.domObj);

    // weight component
    this.components.weight = new paramEditor.LabelAndTextfield("weight", 100, "");
    this.container.appendChild(this.components.weight.domObj);
    ////////////////////////////////////////////////////////////////////////////////////
    // previous components are only for textfield controls
    ////////////////////////////////////////////////////////////////////////////////////


    ////////////////////////////////////////////////////////////////////////////////////////////
    // TEXT CONTROLS (maybe removed)
    ////////////////////////////////////////////////////////////////////////////////////////////
    // ToDo: posiblemente cambiar a un componente que permita aumentar el area para editar su valor
    // text component
    this.components.text = new paramEditor.LabelAndTextfield("text", 250, "");
    this.container.appendChild(this.components.text.domObj);

    // Buttons component
    this.components.Buttons = new paramEditor.LabelAndCheckbox("Buttons", false);
    this.container.appendChild(this.components.Buttons.domObj);

    // ToDo: posiblemente cambiar a un componente que permita aumentar el area para editar su valor
    // answer component
    this.components.answer = new paramEditor.LabelAndTextfield("answer", 250, "");
    this.container.appendChild(this.components.answer.domObj);


    ////////////////////////////////////////////////////////////////////////////////////////////
    // AUDIO & VIDEO CONTROLS (maybe removed)
    ////////////////////////////////////////////////////////////////////////////////////////////
    // file component
    this.components.file = new paramEditor.LabelAndTextfield("file", 250, "");
    this.container.appendChild(this.components.file.domObj);
  }

  /**
   *
   */
  paramEditor.PanelControls.prototype.setEditPanel = function(panel) {
    this.editPanel = panel;
  }

  /**
   *
   */
  paramEditor.PanelControls.prototype.setModelObj = function(objModel) {
    this.objModel = objModel;

    // traverse the values of the components to asign the object model
    for (var propName in this.components) {
      // verify the own properties of the object
      if (this.components.hasOwnProperty(propName)) {
        // show only the attributes of the object
        this.components[propName].domObj.style.display = (objModel[propName] != undefined) ? "inline-block" : "none";

        // verify the own properties of the object
        if (this.components[propName].setModelObj) {
          this.components[propName].setModelObj(objModel, this.editPanel);
        }
      }
    }
  }

  return paramEditor;
})(paramEditor || {});
