/**
 * @author Joel Espinosa Longi
 * @licencia LGPL - http://www.gnu.org/licenses/lgpl.html
 */

var paramEditor = (function(paramEditor) {

  /**
   *
   */
  paramEditor.PanelDefinitions = function(type) {
    this.container = document.createElement("div"),
    this.container.setAttribute("class", "panel");
    this.components = {};

    // id component
    this.components.id = new paramEditor.LabelAndTextfield("id", 100, "");
    this.container.appendChild(this.components.id.domObj);

    this.components.equalsign = { domObj: document.createElement("span") };
    this.components.equalsign.domObj.innerHTML = " = ";
    this.container.appendChild(this.components.equalsign.domObj);

    // evaluate component
    this.components.evaluate = new paramEditor.LabelAndMenu("evaluate", ["onlyOnce"], "onlyOnce");
    this.container.appendChild(this.components.evaluate.domObj);

    // size component
    this.components.size = new paramEditor.LabelAndTextfield("size", 100, "");
    this.container.appendChild(this.components.size.domObj);

    // columns component
    this.components.columns = new paramEditor.LabelAndTextfield("columns", 100, "");
    this.container.appendChild(this.components.columns.domObj);

    // rows component
    this.components.rows = new paramEditor.LabelAndTextfield("rows", 100, "");
    this.container.appendChild(this.components.rows.domObj);

    // expression component
    this.components.expression = new paramEditor.LabelAndTextfield("expression", 300, "");
    this.container.appendChild(this.components.expression.domObj);

    // file component
    this.components.file = new paramEditor.LabelAndTextfield("file", 250, "");
    this.container.appendChild(this.components.file.domObj);

    // range component
    this.components.range = new paramEditor.LabelAndTextfield("range", 300, "");
    this.container.appendChild(this.components.range.domObj);

    // algorithm component
    this.components.algorithm = new paramEditor.LabelAndCheckbox("algorithm", false);
    this.container.appendChild(this.components.algorithm.domObj);

    // ToDo: posiblemente cambiar a un componente que permita aumentar el area para editar su valor
    // local component
    this.components.local = new paramEditor.LabelAndTextfield("local", 250, "");
    this.container.appendChild(this.components.local.domObj);

    this.container.appendChild(document.createElement("br"));

    // ToDo: posiblemente cambiar a un componente que permita aumentar el area para editar su valor
    // init component
    this.components.init = new paramEditor.LabelAndTextfield("init", 250, "");
    this.container.appendChild(this.components.init.domObj);

    this.container.appendChild(document.createElement("br"));

    // ToDo: posiblemente hacer un text area
    // doExpr component
    this.components.doExpr = new paramEditor.LabelAndTextfield("doExpr", 250, "");
    this.container.appendChild(this.components.doExpr.domObj);

    this.container.appendChild(document.createElement("br"));

    // ToDo: posiblemente cambiar a un componente que permita aumentar el area para editar su valor
    // whileExpr component
    this.components.whileExpr = new paramEditor.LabelAndTextfield("whileExpr", 250, "");
    this.container.appendChild(this.components.whileExpr.domObj);
  }

  /**
   *
   */
  paramEditor.PanelDefinitions.prototype.setEditPanel = function(panel) {
    this.editPanel = panel;
  }

  /**
   *
   */
  paramEditor.PanelDefinitions.prototype.setModelObj = function(objModel) {
    this.objModel = objModel;

    // traverse the values of the components to asign the object model
    for (var propName in this.components) {
      // verify the own properties of the object
      if (this.components.hasOwnProperty(propName)) {
        // show only the attributes of the object
        this.components[propName].domObj.style.display = ((objModel[propName] != undefined) || ((propName == "equalsign") && ((objModel.type == "variable") || (objModel.type == "function")))) ? "inline-block" : "none";

        // verify the own properties of the object
        if (this.components[propName].setModelObj) {
          this.components[propName].setModelObj(objModel, this.editPanel);
        }
      }
    }
  }

  return paramEditor;
})(paramEditor || {});
