/**
 * @author Joel Espinosa Longi
 * @licencia LGPL - http://www.gnu.org/licenses/lgpl.html
 */

var paramEditor = (function(paramEditor) {

  /**
   *
   */
  paramEditor.PanelGraphics = function(type) {
    this.container = document.createElement("div"),
    this.container.setAttribute("class", "panel");
    this.components = {};


    // space component
    this.components.space = new paramEditor.LabelAndMenu("space", [], "spinner");
    this.container.appendChild(this.components.space.domObj);

    // background component
    this.components.background = new paramEditor.LabelAndCheckbox("background", false);
    this.container.appendChild(this.components.background.domObj);

    // color component
    this.components.color = new paramEditor.LabelAndColor("color", "");
    this.container.appendChild(this.components.color.domObj);

    // drawif component
    this.components.drawif = new paramEditor.LabelAndTextfield("drawif", 100, 1);
    this.container.appendChild(this.components.drawif.domObj);

    // abs_coord component
    this.components.abs_coord = new paramEditor.LabelAndCheckbox("abs_coord", false);
    this.container.appendChild(this.components.abs_coord.domObj);


    // center component
    this.components.center = new paramEditor.LabelAndTextfield("center", 100, "(0,0)");
    this.container.appendChild(this.components.center.domObj);

    // radius component
    this.components.radius = new paramEditor.LabelAndTextfield("radius", 100, 1);
    this.container.appendChild(this.components.radius.domObj);

    // init component
    this.components.init = new paramEditor.LabelAndTextfield("init", 100, 0);
    this.container.appendChild(this.components.init.domObj);

    // end component
    this.components.end = new paramEditor.LabelAndTextfield("end", 100, 90);
    this.container.appendChild(this.components.end.domObj);

    // vectors component
    this.components.vectors = new paramEditor.LabelAndCheckbox("vectors", false);
    this.container.appendChild(this.components.vectors.domObj);


    // expression component
    this.components.expression = new paramEditor.LabelAndTextfield("expression", 300, "");
    this.container.appendChild(this.components.expression.domObj);

    // trace component
    this.components.trace = new paramEditor.CheckboxAndLabelAndColor("trace", false, "");
    this.container.appendChild(this.components.trace.domObj);

    // useFamily component
    this.components.useFamily = new paramEditor.LabelAndCheckbox("useFamily", false);
    this.container.appendChild(this.components.useFamily.domObj);

    // family component
    this.components.family = new paramEditor.LabelAndTextfield("family", 50, "s");
    this.container.appendChild(this.components.family.domObj);

    // family_parameter component
    this.components.family_parameter = new paramEditor.LabelAndTextfield("family_parameter", 100, "s");
    this.container.appendChild(this.components.family_parameter.domObj);

    // family_interval component
    this.components.family_interval = new paramEditor.LabelAndTextfield("family_interval", 100, "[0,1]");
    this.container.appendChild(this.components.family_interval.domObj);

    // family_steps component
    this.components.family_steps = new paramEditor.LabelAndTextfield("family_steps", 100, 8);
    this.container.appendChild(this.components.family_steps.domObj);

    // parameter component
    this.components.parameter = new paramEditor.LabelAndTextfield("parameter", 100, "s");
    this.container.appendChild(this.components.parameter.domObj);

    // parameter_interval component
    this.components.parameter_interval = new paramEditor.LabelAndTextfield("parameter_interval", 100, "[0,1]");
    this.container.appendChild(this.components.parameter_interval.domObj);

    // parameter_steps component
    this.components.parameter_steps = new paramEditor.LabelAndTextfield("parameter_steps", 100, 8);
    this.container.appendChild(this.components.parameter_steps.domObj);

    // file component
    this.components.file = new paramEditor.LabelAndTextfield("file", 200, "");
    this.container.appendChild(this.components.file.domObj);


    // ToDo: posiblemente cambiar a un componente que permita aumentar el area para editar su valor
    // text component
    this.components.text = new paramEditor.LabelAndTextfield("text", 250, "");
    this.container.appendChild(this.components.text.domObj);

    // decimals component
    this.components.decimals = new paramEditor.LabelAndTextfield("decimals", 250, 2);
    this.container.appendChild(this.components.decimals.domObj);

    // fixed component
    this.components.fixed = new paramEditor.LabelAndCheckbox("fixed", false);
    this.container.appendChild(this.components.fixed.domObj);

    // fill component
    this.components.fill = new paramEditor.CheckboxAndLabelAndColor("fill", false, "");
    this.container.appendChild(this.components.fill.domObj);

    // fillP component
    this.components.fillP = new paramEditor.CheckboxAndLabelAndColor("fillP", false, "");
    this.container.appendChild(this.components.fillP.domObj);

    // fillM component
    this.components.fillM = new paramEditor.CheckboxAndLabelAndColor("fillM", false, "");
    this.container.appendChild(this.components.fillM.domObj);

    // size component
    this.components.size = new paramEditor.LabelAndTextfield("size", 100, 2);
    this.container.appendChild(this.components.size.domObj);

    // width component
    this.components.width = new paramEditor.LabelAndTextfield("width", 100, 1);
    this.container.appendChild(this.components.width.domObj);

    // spear component
    this.components.spear = new paramEditor.LabelAndTextfield("spear", 100, 8);
    this.container.appendChild(this.components.spear.domObj);

    // arrow component
    this.components.arrow = new paramEditor.LabelAndColor("arrow", "");
    this.container.appendChild(this.components.arrow.domObj);

    // visible component
    this.components.visible = new paramEditor.LabelAndCheckbox("visible", false);
    this.container.appendChild(this.components.visible.domObj);

    // editable component
    this.components.editable = new paramEditor.LabelAndCheckbox("editable", false);
    this.container.appendChild(this.components.editable.domObj);

    // range component
    this.components.range = new paramEditor.LabelAndTextfield("range", 100, "[1,100]");
    this.container.appendChild(this.components.range.domObj);

    // inirot component
    this.components.inirot = new paramEditor.LabelAndTextfield("inirot", 100, "0");
    this.container.appendChild(this.components.inirot.domObj);

    // inipos component
    this.components.inipos = new paramEditor.LabelAndTextfield("inipos", 100, "[0,0]");
    this.container.appendChild(this.components.inipos.domObj);

    // name component
    this.components.name = new paramEditor.LabelAndTextfield("name", 100, "");
    this.container.appendChild(this.components.name.domObj);

    // border component
    this.components.border = new paramEditor.CheckboxAndLabelAndColor("border", false, "");
    this.container.appendChild(this.components.border.domObj);

    // info component
    this.components.info = new paramEditor.LabelAndTextfield("info", 100, "");
    this.container.appendChild(this.components.info.domObj);
  }

  /**
   *
   */
  paramEditor.PanelGraphics.prototype.setEditPanel = function(panel) {
    this.editPanel = panel;
  }

  /**
   *
   */
  paramEditor.PanelGraphics.prototype.setModelObj = function(objModel) {
    this.objModel = objModel;

    // traverse the values of the components to asign the object model
    for (var propName in this.components) {
      // verify the own properties of the object
      if (this.components.hasOwnProperty(propName)) {
        // show only the attributes of the object
        this.components[propName].domObj.style.display = (objModel[propName] != undefined) ? "inline-block" : "none";

        // verify the own properties of the object
        if (this.components[propName].setModelObj) {
          this.components[propName].setModelObj(objModel, this.editPanel);
        }
      }
    }
  }

  return paramEditor;
})(paramEditor || {});
