/**
 * @author Joel Espinosa Longi
 * @licencia LGPL - http://www.gnu.org/licenses/lgpl.html
 */

var paramEditor = (function(paramEditor) {

  /**
   *
   */
  paramEditor.PanelGraphics3D = function(type) {
    this.container = document.createElement("div"),
    this.container.setAttribute("class", "panel");
    this.components = {};


    // name component
    this.components.name = new paramEditor.LabelAndTextfield("name", 100, "");
    this.container.appendChild(this.components.name.domObj);

    // space component
    this.components.space = new paramEditor.LabelAndMenu("space", [], "spinner");
    this.container.appendChild(this.components.space.domObj);

    // // background component
    // this.components.background = new paramEditor.LabelAndCheckbox("background", false);
    // this.container.appendChild(this.components.background.domObj);

    // color component
    this.components.color = new paramEditor.LabelAndColor("color", "");
    this.container.appendChild(this.components.color.domObj);

    // backcolor component
    this.components.backcolor = new paramEditor.LabelAndColor("backcolor", "");
    this.container.appendChild(this.components.backcolor.domObj);

    // drawif component
    this.components.drawif = new paramEditor.LabelAndTextfield("drawif", 100, 1);
    this.container.appendChild(this.components.drawif.domObj);

    // expression component
    this.components.expression = new paramEditor.LabelAndTextfield("expression", 300, "");
    this.container.appendChild(this.components.expression.domObj);

    // useFamily component
    this.components.useFamily = new paramEditor.LabelAndCheckbox("useFamily", false);
    this.container.appendChild(this.components.useFamily.domObj);

    // family component
    this.components.family = new paramEditor.LabelAndTextfield("family", 50, "s");
    this.container.appendChild(this.components.family.domObj);

    // family_parameter component
    this.components.family_parameter = new paramEditor.LabelAndTextfield("family_parameter", 100, "s");
    this.container.appendChild(this.components.family_parameter.domObj);

    // family_interval component
    this.components.family_interval = new paramEditor.LabelAndTextfield("family_interval", 100, "[0,1]");
    this.container.appendChild(this.components.family_interval.domObj);

    // family_steps component
    this.components.family_steps = new paramEditor.LabelAndTextfield("family_steps", 100, 8);
    this.container.appendChild(this.components.family_steps.domObj);

    // inirot component
    this.components.inirot = new paramEditor.LabelAndTextfield("inirot", 100, "(0,0,0)");
    this.container.appendChild(this.components.inirot.domObj);

    // inipos component
    this.components.inipos = new paramEditor.LabelAndTextfield("inipos", 100, "(0,0,0)");
    this.container.appendChild(this.components.inipos.domObj);

    // endrot component
    this.components.endrot = new paramEditor.LabelAndTextfield("endrot", 100, "(0,0,0)");
    this.container.appendChild(this.components.endrot.domObj);

    // endpos component
    this.components.endpos = new paramEditor.LabelAndTextfield("endpos", 100, "(0,0,0)");
    this.container.appendChild(this.components.endpos.domObj);

    // split component
    this.components.split = new paramEditor.LabelAndCheckbox("split", false);
    this.container.appendChild(this.components.split.domObj);

    // edges component
    this.components.edges = new paramEditor.LabelAndCheckbox("edges", false);
    this.container.appendChild(this.components.edges.domObj);

    // model component
    this.components.model = new paramEditor.LabelAndMenu("model", ["color", "light", "metal", "wire"], "color");
    this.container.appendChild(this.components.model.domObj);

    // ToDo: posiblemente cambiar a un componente que permita aumentar el area para editar su valor
    // text component
    this.components.text = new paramEditor.LabelAndTextfield("text", 250, "");
    this.container.appendChild(this.components.text.domObj);

    // decimals component
    this.components.decimals = new paramEditor.LabelAndTextfield("decimals", 250, 2);
    this.container.appendChild(this.components.decimals.domObj);

    // fixed component
    this.components.fixed = new paramEditor.LabelAndCheckbox("fixed", false);
    this.container.appendChild(this.components.fixed.domObj);

    // width component
    this.components.width = new paramEditor.LabelAndTextfield("width", 100, 1);
    this.container.appendChild(this.components.width.domObj);

    // depth component
    this.components.depth = new paramEditor.LabelAndTextfield("depth", 100, 2);
    this.container.appendChild(this.components.depth.domObj);

    // length component
    this.components.length = new paramEditor.LabelAndTextfield("length", 100, 2);
    this.container.appendChild(this.components.length.domObj);

    // height component
    this.components.height = new paramEditor.LabelAndTextfield("height", 100, 2);
    this.container.appendChild(this.components.height.domObj);

    // Nu component
    this.components.Nu = new paramEditor.LabelAndTextfield("Nu", 100, 7);
    this.container.appendChild(this.components.Nu.domObj);

    // Nv component
    this.components.Nv = new paramEditor.LabelAndTextfield("Nv", 100, 7);
    this.container.appendChild(this.components.Nv.domObj);

    // info component
    this.components.info = new paramEditor.LabelAndTextfield("info", 100, "");
    this.container.appendChild(this.components.info.domObj);
  }

  /**
   *
   */
  paramEditor.PanelGraphics3D.prototype.setEditPanel = function(panel) {
    this.editPanel = panel;
  }

  /**
   *
   */
  paramEditor.PanelGraphics3D.prototype.setModelObj = function(objModel) {
    this.objModel = objModel;

    // traverse the values of the components to asign the object model
    for (var propName in this.components) {
      // verify the own properties of the object
      if (this.components.hasOwnProperty(propName)) {
        // show only the attributes of the object
        this.components[propName].domObj.style.display = (objModel[propName] != undefined) ? "inline-block" : "none";

        // verify the own properties of the object
        if (this.components[propName].setModelObj) {
          this.components[propName].setModelObj(objModel, this.editPanel);
        }
      }
    }
  }

  return paramEditor;
})(paramEditor || {});
