/**
 * @author Joel Espinosa Longi
 * @licencia LGPL - http://www.gnu.org/licenses/lgpl.html
 */

var paramEditor = (function(paramEditor) {

  /**
   *
   */
  paramEditor.PanelPrograms = function(type) {
    this.container = document.createElement("div"),
    this.container.setAttribute("class", "panel");
    this.components = {};


    // id component
    this.components.id = new paramEditor.LabelAndTextfield("id", 100, "");
    this.container.appendChild(this.components.id.domObj);

    // condition component
    this.components.condition = new paramEditor.LabelAndTextfield("condition", 250, "");
    this.container.appendChild(this.components.condition.domObj);

    // action component
    this.components.action = new paramEditor.LabelAndMenu("action", ["", "calculate", "open URL", "open Scene", "init", "clear", "animate", "Init Animation", "play"], "");
    this.container.appendChild(this.components.action.domObj);

    // ToDo: posiblemente cambiar a un componente que permita aumentar el area para editar su valor
    // parameter component
    this.components.parameter = new paramEditor.LabelAndTextfield("parameter", 250, "");
    this.container.appendChild(this.components.parameter.domObj);

    // execution component
    this.components.execution = new paramEditor.LabelAndMenu("execution", ["onlyOnce", "alternate", "always"], "onlyOnce");
    this.container.appendChild(this.components.execution.domObj);

    // evaluate component
    this.components.evaluate = new paramEditor.LabelAndMenu("evaluate", ["onlyOnce", "always"], "onlyOnce");
    this.container.appendChild(this.components.evaluate.domObj);

    // ToDo: posiblemente cambiar a un componente que permita aumentar el area para editar su valor
    // init component
    this.components.init = new paramEditor.LabelAndTextfield("init", 250, "");
    this.container.appendChild(this.components.init.domObj);

    this.container.appendChild(document.createElement("br"));

    // ToDo: posiblemente hacer un text area
    // doExpr component
    this.components.doExpr = new paramEditor.LabelAndTextfield("doExpr", 250, "");
    this.container.appendChild(this.components.doExpr.domObj);

    this.container.appendChild(document.createElement("br"));

    // ToDo: posiblemente cambiar a un componente que permita aumentar el area para editar su valor
    // whileExpr component
    this.components.whileExpr = new paramEditor.LabelAndTextfield("whileExpr", 250, "");
    this.container.appendChild(this.components.whileExpr.domObj);

  }

  /**
   *
   */
  paramEditor.PanelPrograms.prototype.setEditPanel = function(panel) {
    this.editPanel = panel;
  }

  /**
   *
   */
  paramEditor.PanelPrograms.prototype.setModelObj = function(objModel) {
    this.objModel = objModel;

    // traverse the values of the components to asign the object model
    for (var propName in this.components) {
      // verify the own properties of the object
      if (this.components.hasOwnProperty(propName)) {
        // show only the attributes of the object
        this.components[propName].domObj.style.display = (objModel[propName] != undefined) ? "inline-block" : "none";

        // verify the own properties of the object
        if (this.components[propName].setModelObj) {
          this.components[propName].setModelObj(objModel, this.editPanel);
        }
      }
    }
  }

  return paramEditor;
})(paramEditor || {});
